m = 1.0;
r = 0.1;
l = 1.0;
h = l/2;
J = (1/4)*m*r*r + (1/12)*m*l*l;
g = 9.81;

//Linearisierung:

// phi.. = (mgh*phi + F*h) / J
// [phi.;om.] = A * [phi;om] + B * F
A = [  0         1
       m*g*h/J   0];

B = [  0
       h/J];

spec(A)

R = ppol(A,B,[-10+%i*10,-10-%i*10])

// - B*R*y => F = -R*y

function f = rechteSeite(t,y)
    phi = y(1,1);
    om  = y(2,1);

    f(1,1) = om;

    sp = sin(phi);
    cp = cos(phi);

    //F = 0;

    r1 = R(1);
    r2 = R(2);

    F = -r1*phi - r2*om;

    Z = -m*h*h*om*om*cp*sp + m*g*h*sp + F*h*cp;
    N = J + m*h*h*sp*sp;

    f(2,1) = Z/N;

endfunction

t = linspace(0,30,3000);

y0 = [1,0]';
t0 = 0;
y  = ode(y0,t0,t,rechteSeite);

plot(t,y(1,:)',t,y(2,:)');