//Doppelt simuliert

m = 1.0;
r = 0.1;
l = 1.0;
h = l/2;
J = (1/4)*m*r*r + (1/12)*m*l*l;
g = 9.81;

//Linearisierung:

// phi.. = (mgh*phi + F*h) / J
// [phi.;om.] = A * [phi;om] + B * F
A = [  0         1
       m*g*h/J   0];

B = [  0
       h/J];

spec(A)

R = ppol(A,B,[-10+%i*10,-10-%i*10])

// - B*R*y => F = -R*y

function f = rechteSeite(t,y)

    //--------- 1. Simulation -------
    //  "Original" / "realses System"

    phi = y(1,1);
    om  = y(2,1);

    f(1,1) = om;

    sp = sin(phi);
    cp = cos(phi);

    //F = 0;

    r1 = R(1);
    r2 = R(2);

    F = -r1*phi - r2*om;

    Z = -m*h*h*om*om*cp*sp + m*g*h*sp + F*h*cp;
    N = J + m*h*h*sp*sp;

    f(2,1) = Z/N;

    //-----------  2. Simulation ---------------
    // "MODELL"

    phi2 = y(3,1);
    om2  = y(4,1);

    f(3,1) = om2;

    sp2 = sin(phi2);
    cp2 = cos(phi2);

    //F = 0;

    r12 = R(1);
    r22 = R(2);

    F2 = -r12*phi2 - r22*om2;

    Z2 = -m*h*h*om2*om2*cp2*sp2 + m*g*h*sp2 + F2*h*cp2;
    N2 = J + m*h*h*sp2*sp2;

    f(4,1) = Z2/N2;


endfunction

t = linspace(0,30,3000);

y0 = [1,0,1,0]';
t0 = 0;
y  = ode(y0,t0,t,rechteSeite);

plot(t,y(1,:)',t,y(2,:)',t,y(3,:)',t,y(4,:)');


