clear();

//Jetzt wird y-ysim auch auf die erste DGL in der Simulation Einfluß nehmen

//Jetzt wird der Beobachter implementiert!

//Um den positiven Effekt zu sehen, wurde der Startregelabweichung verkleinert.
//Schon der numerische Fehler reicht als Störung.


//ALTERNATIVE L, die Gewichte wurden experimentell ermittelt:

//So wird es nicht instabil:
//L = [3,3;3,3];

//phi nicht meßbar:
L = [0,1;0,1];
//L = [0,0.1;0,0.1];

//omega nicht meßbar:
//L = [1,0;1,0];

//So wird es instabil:
//L = [0,0;0,0];

//das reale System regeln:

//     Orig.:
//   usim-->G-->y
//
//     Sim.:
//   O---R-u-G--y
//  -|          |
//   |----------|
//
//   u==usim==F

// Schon die numerischen Fehler reichen aus, um 
// beide Systeme auf Dauer auseinander driften zu lassen!
// ... nach ca. 6 Sekunden Simulation

m = 1.0;
r = 0.1;
l = 1.0;
h = l/2;
J = (1/4)*m*r*r + (1/12)*m*l*l;
g = 9.81;

//Linearisierung:

// phi.. = (mgh*phi + F*h) / J
// [phi.;om.] = A * [phi;om] + B * F
A = [  0         1
       m*g*h/J   0];

B = [  0
       h/J];

spec(A)

//R = ppol(A,B,[-10+%i*10,-10-%i*10])
R = ppol(A,B,[-10+%i*10,-10-%i*10])

// - B*R*y => F = -R*y

function f = rechteSeite(t,y)

    phi = y(1,1);
    om  = y(2,1);

    //-----------  2. Simulation ---------------
    // "MODELL"

    phi2 = y(3,1);
    om2  = y(4,1);

    f(3,1) = om2 + L(1,1)*(phi-phi2) + L(1,2)*(om-om2);

    sp2 = sin(phi2);
    cp2 = cos(phi2);

    //F = 0;

    r12 = R(1);
    r22 = R(2);

    //F2 = -r12*phi2 - r22*om2;
    F2 = -r12*phi2 - r22*om2 + L(2,1)*(phi-phi2) + L(2,2)*(om-om2);

    Z2 = -m*h*h*om2*om2*cp2*sp2 + m*g*h*sp2 + F2*h*cp2;
    N2 = J + m*h*h*sp2*sp2;

    f(4,1) = Z2/N2;


    //--------- 1. Simulation -------
    //  "Original" / "realses System"

    //phi = y(1,1);
    //om  = y(2,1);  .. siehe oben!

    f(1,1) = om;

    sp = sin(phi);
    cp = cos(phi);

    //F = 0;

    r1 = R(1);
    r2 = R(2);

    //Hier wird das Stellsignal aus dem Originalzustand bestimmt:
    //F = -r1*phi - r2*om;
    //Nun aber wird das Stellsignal aus der Simulation genommen:
    F = F2;

    Z = -m*h*h*om*om*cp*sp + m*g*h*sp + F*h*cp;
    N = J + m*h*h*sp*sp;

    f(2,1) = Z/N;

endfunction

t = linspace(0,300,30000);

y0 = [0.1,0,0.100001,0]';
t0 = 0;
y  = ode(y0,t0,t,rechteSeite);

plot(t,y(1,:)',t,y(2,:)',t,y(3,:)',t,y(4,:)');


